reportUnusedDisableDirectives: true
env:
  node: true
  jest: true
  es2021: true

extends:
  - eslint:recommended
  - plugin:eslint-comments/recommended
  - plugin:promise/recommended
  - plugin:jest/recommended
  - plugin:jest/style

parser: "@babel/eslint-parser"
parserOptions:
  sourceType: module
  ecmaVersion: 2021
  ecmaFeatures:
    impliedStrict: true
plugins:
  - babel

ignorePatterns:
  - 'coverage/*'

rules:
  quotes:
    - error
    - single
  no-unused-vars:
    - error
    - ignoreRestSiblings: true
  eol-last:
    - error
    - always
  object-curly-spacing:
    - error
    - always
  eqeqeq:
    - error
    - smart
  no-var:
    - error
  prefer-const:
    - error
  arrow-body-style:
    - error
    - as-needed
  arrow-parens:
    - warn
    - as-needed
    - requireForBlockBody: true
  arrow-spacing:
    - error
  #eslint-comments/require-description:
  #  - error
  #eslint-comments/no-use:
  #  - error
  #  - allow: []
  no-confusing-arrow:
    - error
  no-constructor-return:
    - error
  consistent-return:
    - warn
  prefer-template:
    - error
  no-extra-parens:
    - warn
    - all
    - ignoreJSX: all
      enforceForNewInMemberExpressions: false
  no-promise-executor-return:
    - error
  no-template-curly-in-string:
    - error
  no-unsafe-optional-chaining:
    - error
  require-atomic-updates:
    - error
  array-callback-return:
    - error
  complexity:
    - error
    - max: 10
  dot-notation:
    - error
  #guard-for-in:
  #  - error
  max-classes-per-file:
    - error
  no-else-return:
    - error
    - allowElseIf: false
  no-eval:
    - error
  no-implied-eval:
    - error
  no-floating-decimal:
    - error
  no-multi-spaces:
    - error
  no-multi-str:
    - error
  no-new-wrappers:
    - error
  no-return-assign:
    - error
  no-self-compare:
    - error
  no-useless-call:
    - error
  yoda:
    - warn
    - never
  no-await-in-loop:
    - error
  babel/new-cap:
    - error
  #babel/no-unused-expressions:
  #  - warn
  babel/semi:
    - error
